<?php
/**
 * Created by PhpStorm.
 * User: root
 * Date: 20.01.16
 * Time: 15:38
 */
define('_PS_MODE_DEV_', false);
include_once(dirname(__FILE__) . '/../../../config/config.inc.php');
Context::getContext()->controller = 'AdminController';
include_once(dirname(__FILE__) . '/../../../init.php');
require_once ( dirname(__FILE__) . '/../libraries/JWT/Jwt.php');

class synchronization
{
  public function __construct()
  {
	@ini_set('memory_limit', '-1');
    @ini_set('max_execution_time', "0");
    $data = file_get_contents("php://input");
    $data = json_decode($data, true);
    if( !$data['jwt'] || !$data['key'] ){
      throw new Exception('Authentication failed!');
    }
    JWT_Jwt::decode($data['jwt'], new JWT_Key($data['key'], 'HS256'));
  }
  public function getData()
  {
    $data = file_get_contents("php://input");
    $data = json_decode($data, true);
    $json = array();
    if( $data['action'] == 'categories' ){
      $json['categories'] = $this->getCategories();
      $json['root_category_id'] = Configuration::get('PS_ROOT_CATEGORY');
    }

    if( $data['action'] == 'languages' ){
      $json['languages'] = $this->getLanguages();
    }

    if( $data['action'] == 'check-access' ){
      $json['success'] = true;
    }

    if( $data['action'] == 'brands' ){
      $json['brands'] = $this->getBrands();
    }

    if( $data['action'] == 'suppliers' ){
      $json['suppliers'] = $this->getSuppliers();
    }

    if( $data['action'] == 'shops' ){
      $json['shops'] = $this->getShops();
    }

    if( $data['action'] == 'attributes' ){
      $json['attributes'] = $this->getAttributes();
    }

    if( $data['action'] == 'features' ){
      $json['features'] = $this->getFeatures();
    }

    if( $data['action'] == 'dump' ){
      $res = $this->getDataBase();
      $json['dump'] = true;
      $json['skip_lock'] = $res['skip_lock'];
    }

    if( $data['action'] == 'shop_info' ){
      $json = $this->getShopInfo();
    }

    if( $data['action'] == 'tax_rules' ){
      $json['tax_rules'] = $this->getTaxRules();
    }

    if( $data['action'] == 'employee_id' ){
      $json['employee_id'] = $this->getEmployeeId();
    }

    if( $data['action'] == 'upload-dump' ){
      $this->uploadDump($data['link']);
      $json['success'] = true;
    }

    if( $data['action'] == 'upload-img-dump' ){
      $this->uploadImgDump($data['link']);
      $json['success'] = true;
    }

    if( $data['action'] == 'unzip-img-dump' ){
      $this->unzipImgDump();
    }

    if( $data['action'] == 'check-functions' ){
      $json['functions'] = $this->checkFunctions();
    }

	$json['success'] = true;
    return $json;
  }

  public function uploadImgDump($link)
  {
    $path = dirname(__FILE__) . '/../files/';
    if( file_exists($path.'img-dump.zip') ){
      unlink($path.'img-dump.zip');
    }

    $command = 'wget --no-check-certificate -O ' . $path . 'img-dump.zip "' . $link . '"';
    exec($command, $output, $res);
    if( $res ){
      throw new Exception('Can not download images');
    }
  }

  public function unzipImgDump()
  {
    $path = dirname(__FILE__) . '/../files/img-dump.zip';
    $zip = new ZipArchive;
    $res = $zip->open($path);
    if ($res === TRUE) {
      $zip->extractTo(_PS_IMG_DIR_);
      $zip->close();
    }
    else {
      throw new Exception( 'Can not unzip your dump!' );
    }
  }

  public function uploadDump( $link )
  {
    $this->_clearFiles();
    $path = dirname(__FILE__) . '/../files/';
    $command = 'wget --no-check-certificate -O ' . $path . 'dump.zip "' . $link . '"';
    exec($command, $output, $res);
    if( $res ){
      throw new Exception('Can not download dump');
    }

    require_once ( dirname(__FILE__) . '/connect_db.php');
    $db = new connectDB();
    $db->restoreDump();
    $this->_clearFiles();
  }

  private function _clearFiles()
  {
    $path = dirname(__FILE__) . '/../files/';
    if( file_exists($path.'dump.sql') ){
      unlink($path.'dump.sql');
    }
    if( file_exists($path.'dump.zip') ){
      unlink($path.'dump.zip');
    }
    if( file_exists($path.'img-dump.zip') ){
      unlink($path.'img-dump.zip');
    }
  }

  public function getFeatures()
  {
    return Feature::getFeatures( Configuration::get('PS_LANG_DEFAULT') );
  }

  public function getAttributes()
  {
    return AttributeGroup::getAttributesGroups(Configuration::get('PS_LANG_DEFAULT'));
  }

  public function getLanguages()
  {
    return Language::getLanguages();
  }

  public function getShops()
  {
    return Shop::getShops();
  }

  public function getCategories()
  {
    $sql = "
			SELECT c.id_category, c.id_parent, cl.name as category_name
      FROM " . _DB_PREFIX_ . "category c
      INNER JOIN " . _DB_PREFIX_ . "category_lang cl
      ON cl.id_category = c.id_category AND cl.id_shop = c.id_shop_default
      WHERE cl.id_lang = ".Configuration::get('PS_LANG_DEFAULT')."
      AND c.level_depth > 0
			";

    $res = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
    return $res;
  }

  public function getBrands()
  {
    return Manufacturer::getManufacturers(false, 0, false);
  }

  public function getSuppliers()
  {
    return Supplier::getSuppliers(false, 0, false);
  }

  public function getShopInfo()
  {
    $data = array();
    $data['ps_version'] = _PS_VERSION_;
    $data['id_shop'] = Context::getContext()->shop->id;
    $data['db_prefix'] = _DB_PREFIX_;
    $data['module_version'] = Module::getInstanceByName('prestasyncmaster')->version;

    return $data;
  }

  public function getTaxRules()
  {
    return TaxRulesGroup::getTaxRulesGroups();
  }

  public function getDataBase()
  {
    require_once ( dirname(__FILE__) . '/connect_db.php');
    $db = new connectDB();
    return $db->backupTables();
  }

  public function getEmployeeId()
  {
    $sql = 'SELECT `id_employee`
			FROM `' . _DB_PREFIX_ . 'employee`
			WHERE `active` = 1
			ORDER BY `id_employee` ASC
			LIMIT 1
			';

    $res = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
    if( $res ){
      return $res[0]['id_employee'];
    }

    return false;
  }

  public function checkFunctions()
  {
    $data = array(
      'exec' => $this->_exec_enabled(),
      'zip'  => class_exists('ZipArchive'),
      'wget' => $this->_checkExecFunction('wget'),
      'mysqldump' => $this->_checkExecFunction('mysqldump'),
      'mysql' => $this->_checkExecFunction('mysql'),
    );

    return $data;
  }

  private function _checkExecFunction( $command )
  {
	if( !$this->_exec_enabled() ){
      return false;
    }
    $command = $command . ' --help';
    exec($command, $output, $res);
    if( $res ){
      return false;
    }

    return  true;
  }

  private function _exec_enabled()
  {
    $disabled = explode(',', ini_get('disable_functions'));
    $disabled = array_map('trim', $disabled);
    return !in_array('exec', $disabled);
  }
}

try{
  $sync = new synchronization();
  $json = $sync->getData();
  echo json_encode($json);
}
catch(Exception $e){
  $json = array();
  $json['error'] = $e->getMessage();
  echo json_encode($json);
}