<?php

if (!defined('_PS_VERSION_')){
  exit;
}

class prestasyncmaster extends Module {

  public function __construct(){

    $this->name = 'prestasyncmaster';
    $this->tab = 'quick_bulk_update';
    $this->version = '1.0.5';
    $this->author = 'MyPrestaModules';
    $this->need_instance = 0;
    $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
    $this->bootstrap = true;

    parent::__construct();

    $this->displayName = $this->l('PrestaShop Sync Master');
    $this->description = $this->l('Easy Way to Import/Update PrestaShop Products Catalog');
  }

  public function install()
  {
    $this->_checkOldModule();
    if ( !parent::install() ) {
      return false;
    }

    return true;
  }

  public function uninstall(){

    return parent::uninstall();
  }

    public function getContent()
    {
        $url = 'https://presta-sync-master.com/module-version';
        if ( _PS_BASE_URL_ == 'http://gomakoil' ) {
            $url = 'http://yura-sync-master.gomakoil.com/module-version';
        }

        if( Tools::getValue('configure') == 'prestasyncmaster' ){
            $this->context->controller->addCSS($this->_path . 'views/css/mpm_connector.css');
            $this->context->controller->addCSS($this->_path . 'views/css/fonts/stylesheet.css');
            $this->context->controller->addCSS($this->_path . 'views/css/fonts/icons/style.css');
        }

        $module = file_get_contents( $url );
        if ( $module ) {
            $module = explode('|', $module);
        }

        $this->context->smarty->assign(array(
            'exec' => $this->_exec_enabled(),
            'zip'  => class_exists('ZipArchive'),
            'wget' => $this->_checkExecFunction('wget'),
            'mysqldump' => $this->_checkExecFunction('mysqldump'),
            'mysql' => $this->_checkExecFunction('mysql'),
            'running_module_version' => $this->version,
            'module' => $module,
            'module_path'                 => Tools::getShopDomainSsl(true, true) . __PS_BASE_URI__ . basename(_PS_MODULE_DIR_) . '/prestasyncmaster/',
            'store_url' => Tools::getShopDomainSsl(true, true) . __PS_BASE_URI__
        ));
        return $this->display(__FILE__, 'views/templates/admin/welcome.tpl');
    }

    private function _checkOldModule()
    {
      if(Module::getInstanceByName('mpm_connector')){
        Module::getInstanceByName('mpm_connector')->uninstall();
        $this->_removeOldModule(_PS_MODULE_DIR_ . 'mpm_connector/', true);
      }
    }

    private function _removeOldModule( $path, $removeDir = false )
    {
      if( file_exists($path) ){
        foreach (scandir($path) as $d) {
          if ( is_file($path.$d) ) {
            unlink($path.$d);
          }
          elseif( is_dir( $path.$d ) ){
            if($d == '.' || $d == '..'){
              continue;
            }
            $this->_removeOldModule($path.$d . '/', true);
          }
        }

        if( $removeDir ){
          rmdir($path);
        }
      }
    }

    private function _checkExecFunction( $command )
    {
	  if( !$this->_exec_enabled() ){
        return false;
      }
      
	    $command = $command . ' --help';
	    exec($command, $output, $res);
	    if( $res ){
	        return false;
	    }
	
	    return  true;
    }

    private function _exec_enabled()
    {
        $disabled = explode(',', ini_get('disable_functions'));
        $disabled = array_map('trim', $disabled);
        return !in_array('exec', $disabled);
    }

}
